package org.apache.bcel.classfile;

import java.io.IOException;
import java.io.DataInput;

public final class ConstantDynamic extends ConstantCP
{
    public ConstantDynamic(final ConstantDynamic c) {
        this(c.getBootstrapMethodAttrIndex(), c.getNameAndTypeIndex());
    }
    
    ConstantDynamic(final DataInput file) throws IOException {
        this(file.readShort(), file.readShort());
    }
    
    public ConstantDynamic(final int bootstrapMethodAttrIndex, final int nameAndTypeIndex) {
        super((byte)17, bootstrapMethodAttrIndex, nameAndTypeIndex);
    }
    
    @Override
    public void accept(final Visitor v) {
        v.visitConstantDynamic(this);
    }
    
    public int getBootstrapMethodAttrIndex() {
        return super.getClassIndex();
    }
    
    @Override
    public String toString() {
        return super.toString().replace("class_index", "bootstrap_method_attr_index");
    }
}
